# $Id: dirnav.sh,v 1.3 2000/09/04 15:45:48 dmetz Exp $
# $crtd: by  Derald Metzger  on  981105 $
# $cmnt: Directory navigation functions. Source these during shell init.
#                Copyright (c) 1998 1999 2000  Derald Metzger
# This file is part of the cfm pkg (GPL).
# $

# clear screen. tput for widest support
cs() { tput clear; echo PWD=`pwd`; }

# dir list cmds
d() { if [ -z "$*"  ]; then echo "## ls -aCF `(exec pwd)`"; ls -aCF
      else echo "## ls -aCF $*"; ls -aCF "$@"; fi;
}
dl() { if [ -z "$*"  ]; then echo "## ls -aFl `(exec pwd)`"; ls -aFl
       else echo "## ls -aFl $*"; ls -aFl "$@"; fi;
}

rmbak() {
bakids='*~ .*~ #*# *.bak .*.bak core'
echo "## -f rm $bakids"
rm -f $bakids
}

# g cmds echo the intended change of the current working dir, then execute it
# HOME supports sh
g() { echo "## cd ${1:-`pwd`}"; cd ${1:-`pwd`};  }
gb() { g $HOME/bin; }
ge() { g $HOME/etc; }
gh() { g $HOME/hold; }
gs() { g $HOME/scr; } #NOTE: may preempt ghostscript, alias it to gsc
gw() { g $HOME/work; }

# p cmd changes current working dir and lists content of the new dir
p() { g $1; if [ $? -eq 0 ]; then echo "## ls -ACF"; ls -ACF; fi; }
