# $Id: cfm.spec,v 1.45 2000/09/20 00:32:24 dmetz Exp $
# $crtd:  by  Derald Metzger  on  990210 $
# $cmnt:  spec file for cfm $

# Preamble
Summary: Config File Manager & utils
Name: cfm
Version: 1.0.0
Release: 1
Copyright: GPL
Group: Utilities/System
Source: ftp://ftp.remotesensing.org/pub/%{name}-%{version}.tgz
URL: http://www.remotesensing.org/cfm/
Distribution: na
Vendor: remotesensing.org
Packager: Derald Metzger <dmetz@remotesensing.org>
Provides: cfm, dirnav
Requires: rcs, rpm
BuildRoot: %{_tmppath}/%{name}-%{version}

%description

Cfm is a configuration file manager and monitoring utility. It is
used to provide control of the system environments for development, 
test, and production. With its use you can guarantee proper functioning
of tested and delivered software systems. It provides audit, capture,
recovery, comparison and documentation trail for config files and
integrity monitoring for all rpm installed files. It is cumbersome to
setup on a complex network, reasonably demanding to maintain, but
very effective in delivering a known, controlled system software
environment.

%prep
%setup
rm -r `find . -name CVS -print` 

%build
# Embed version info
sed -e 's/^$cfm_ver_rel =.*$/$cfm_ver_rel = "cfm-%{version}-%{release}";         # Build fills this in/' <sbin/Cfm.pm >Cfm.pm_$$
mv Cfm.pm_$$ sbin/Cfm.pm
mkdir html
mv doc/html/index.html html
for i in `ls doc/overview/*.pod; ls doc/man1/*; ls doc/man8/*`; do
  j=`echo $i | cut -d. -f1 | cut -d/ -f3`
  pod2html --htmlroot=%{_docdir}/%{name}-%{version}/html $i >html/$j.html
done
mkdir man1
for i in `ls doc/man1/*.pod`; do
  j=`echo $i | cut -d. -f1 | cut -d/ -f3`
  pod2man $i >man1/$j.1
done
mkdir man8
for i in `ls doc/man8/*.pod`; do
  j=`echo $i | cut -d. -f1 | cut -d/ -f3`
  pod2man $i >man8/$j.8
done

%install
IR=$RPM_BUILD_ROOT  # Install root
[ -d $IR ] && %{__rm} -r $IR  # Clear the work area
# Install can't handle symlinks. remove and recreate'em
# Get perl version
perlver=`rpm -q perl | cut -c6-10`
%{__install} -d $IR%{_sysconfdir}/cfm $IR%{_sysconfdir}/cron.daily $IR%{_sysconfdir}/rc.d/init.d $IR%{_bindir} $IR%{_docdir}/%{name}-%{version}/html $IR%{_mandir}/man1 $IR%{_mandir}/man8 $IR/usr/lib/perl5/site_perl/$perlver $IR%{_sbindir}
%{__install} bin/* $IR%{_bindir}
%{__install} doc/README doc/Todo doc/cfm.spec doc/worklog $IR%{_docdir}/%{name}-%{version}
%{__install} html/* $IR%{_docdir}/%{name}-%{version}/html
%{__mv} etc/cfmstatusreport $IR%{_sysconfdir}/cron.daily
%{__mv} etc/chk.cfm $IR%{_sysconfdir}/rc.d/init.d
%{__install} -m 644 etc/* $IR%{_sysconfdir}/cfm
%{__install} -m 644 man1/* $IR%{_mandir}/man1
%{__rm} -f man8/wleh.8
%{__install} -m 644 man8/* $IR%{_mandir}/man8
%{__ln_s} ./wle.8 $IR%{_mandir}/man8/wleh.8
%{__mv} sbin/Cfm.pm $IR%{_libdir}/perl5/site_perl/$perlver
%{__rm} -f sbin/wleh
%{__install} sbin/* $IR/usr/sbin
%{__ln_s} -f ./wle $IR/usr/sbin/wleh

%changelog
* Wed Sep 06 2000 Derald Metzger <dmetz@remotesensing.org>
- Remove bulliten board cmds; unused.
  These are just copies of worklog cmds anyhow.
- Redo doc using perl pod. Add a lot of manpages.
* Sat Sep 02 2000 Derald Metzger <dmetz@remotesensing.org>
- Replace rpmdfp, rpmsfm, rpmsfug with cfmugm to handle restore of 
  file user, group, and mode using info from from rpmdb.
* Thu Aug 31 2000 Derald Metzger <dmetz@remotesensing.org>
- Remove rhbackup. Its still available from redhat in the 5.2 stuff.
  Using ftp.remotsensing.org/pub/rhbackup/rhbackup-0.2-1dam.noarch.rpm here.
  I've submitted a bug report.
* Mon Aug 7 2000 Derald Metzger <dmetz@remotesensing.org>
- Fix skip of non-existant file during dir expansion
- Add d & dl cmds to support csh style shells. Problem with csh aliases.
* Wed Jun 28 2000 Derald Metzger <dmetz@remotesensing.org>
-UPDATE to 0.99.9b  Hopefully 1.0.0 will follow; no promises.
- rhbackup: Added the rhbackup stuff. RedHat discountinued distribution?
  I've added extensions and fixes for remote backups.
- whatsout: Added whatsout by Dave Burken. Finds cvs tree changes
- allfiles: Put in some more sample lines.
- cfm.cf: tweaked the filtering some more
- idd: now works for rh62
- hsfiles: add /etc/cfm/fdisk-l
- cfm: allow `-s<rpm>' to specify owning rpm as the set name
- cfmdb: -F & -L opts to allow erase in cfmdb when files don't exist on host
- cfmh: -m option to update monitor files only
- cfmhrlis: move filtering to cfm.cf
- scmd: fix for yp & non-yp envs, also for csh env
* Tue May 02 2000 Derald Metzger <dmetz@remotesensing.org>
-UPDATE to 0.99.8b
- config: Add /export to $os_dirs. Add '-I^# $Id: ' to diff opts.
- Moved dir expansion from Cfm.pm to cfm. 
  Split arch and dataclass checks.
  Changed routine name from v_t_nodes to vt_nodes.
- cfm: added -D option to allow treating a dir symlink as a dir.
- cfm: ignore non-existant files during dir expansion, err otherwise.
* Tue Apr 25 2000 Derald Metzger <dmetz@remotesensing.org>
- cfm: No set: is not an err
- cfmstatusreport: do cfmhs . first to update chk.cfm & rpm-qa.sort
* Sun Apr 23 2000 Derald Metzger <dmetz@remotesensing.org>
- UPDATE to 0.99.7b
- cfm: Treat top 2 dirs on non-`os_dirs' as mapping dirs,
  ie follow symlinks at this level.
* Fri Apr 21 2000 Derald Metzger <dmetz@remotesensing.org> 
- cfm.cf: More verify filtering.
- cfm: Fix download of non-existant files
* Thu Apr 20 2000 Derald Metzger <dmetz@remotesensing.org> 
- UPDATE to 0.99.6b
- Add `No hostset' warning to cfm cdm.
- Fix cfmdb to support init of rpms with `+' in their names.
* Wed Apr 19 2000 Derald Metzger <dmetz@remotesensing.org> 
- Added rpm-qa.sort to track rpm complement. 
* Tue Apr 18 2000 Derald Metzger <dmetz@remotesensing.org> 
- UPDATE to 0.99.5b
- Added rpmfixes admin file to allow auto add/remove of problem config 
  files when the rpm is initialized in the cfmdb.
- Fixed multiple copies of hostset line on reexecution of cfmdb -ih.
* Wed Apr 12 2000 Derald Metzger <dmetz@remotesensing.org> 
- UPDATE to 0.99.4b
- Add cfmstatusreport to cron.daily.
- Add more files to allfiles and hsfiles lists.
- Fix bug in v_t_nodes: failed type catagorization in loop.
- Move dir expansion into param parsing (v_t_nodes).
* Wed Apr 12 2000 Derald Metzger <dmetz@remotesensing.org> 
- UPDATE to 0.99.3b
- Fix broken symlink support.
- Update beginning.pod, old file was initdb
* Tue Apr 11 2000 Derald Metzger <dmetz@remotesensing.org> 
- UPDATE to 0.99.2b
- Default sets are now configurable in CFMROOT/config. Initially set to
  "<rpm> all $LOGNAME". <rpm> get replaced by the name of the owning rpm.
- Restored ability to modify mulitple hostsets with a single cfmdb -h cmd.
- "cfmdb --initdb" initializes the "all" set. This set should accomodate
  non-rpm owned common files in the cfmdb. Initially contains /etc/hosts,
  /etc/rc.d/init.d/chk.cfm. 
- "cfmdb --init --host <host>" initializes the SVR4 runcmd symlinks as
  host specific files including the set of SVR4 runcmd symlinks.
- `cfmh' cmd is to automatically gen the chk.cfm file holding the SVR4
  symlink status each time it is executed. Uses `chkconfig --list'.
* Sat Apr 1 2000 Derald Metzger <dmetz@remotesensing.org> 
- UPDATE to 0.99.1b
- This is the initial beta release for cfm-1.
- Cfm-1 beta consists of new cfmdb and cfm cmds with continued use of
  most other parts of cfm-0. Both new cmds use the name of the rpm 
  that owns a config file as the default set name for that file.
  This results in a major simplification of database setup and management.
- The cfmdb cmd is the exclusive means used to initialize, configure,
  and otherwise manage the addition or removal of elements of the cfm
  databbase. It also includes additional new control and analysis
  capabilities. The cfmdb cmd syntax is modeled after the rpm cmd. The
  internal structure of the pkg resembles cvs.
- The cfm cmd continues to provide comparision, update, and
  documentaion for individual config file versions.
- It is possible to use the new cfm pkg with an old cfmdb. Your success
  in doing this will vary with the manner in which you have assigned
  set names. If you have used the rpm names as set names it might be
  worth a try. 
- In an attempt to extend cfm support to individual users the $LOGNAME 
  has been added as 2nd default set name. All that should be required 
  to support users is to create and set ownership and permissions on 
  a dir for each user in the cfmdb, eg $CFMROOT/home/dmetz.

%files
%defattr(-,root,root)
%config %{_sysconfdir}/cfm/allfiles
%config %{_sysconfdir}/cfm/cfm.cf
%config %{_sysconfdir}/cfm/config
%config %{_sysconfdir}/cfm/hostsets
%config %{_sysconfdir}/cfm/hsfiles
%config %{_sysconfdir}/cfm/dirnav.sh
%config %{_sysconfdir}/cfm/dirnav.csh
%config %{_sysconfdir}/cfm/rpm-qa.sort
%config %{_sysconfdir}/cfm/rpmfixes
%config %{_sysconfdir}/cron.daily/cfmstatusreport
%config %{_sysconfdir}/rc.d/init.d/chk.cfm
%{_libdir}/perl5/site_perl/5.005
%{_bindir}
%{_docdir}
%{_mandir}/man[18]
%{_sbindir}
